Index: options/SPECIES/SPECIES.README
===================================================================
--- options/SPECIES/SPECIES.README	(revision 57d098f63f43e3ca7e802a1a2440a1e67df1fa62)
+++ options/SPECIES/SPECIES.README	(revision 57d098f63f43e3ca7e802a1a2440a1e67df1fa62)
@@ -0,0 +1,98 @@
+Specifies all physico-chemical properties for the species. 
+--------------------------------------------------------------------------------------------------------------------------------------------------------|
+    Specie    | Radioact.  | WetDep(below-Cl)| WetDep(in-Cl)|     DryDepo(gas)   |     DryDepo(particles)     Alt.  |          |      OH Reaction       |
+    Name      | Halflife[s]|    A         B  |   Ai    Bi   |   D      H     f0  |   rho    dquer    dsig      vd   | molweight|    C**     D[T]  N***  |
+--------------------------------------------------------------------------------------------------------------------------------------------------------|
+  1 TRACER    |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   | -9.9               | -9.9E09                   -9.99  |  350.0   | -9.9E-09   -9.9  -9.9  |
+  2 O3        |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   |  1.5  1.0e-02  1.0 | -9.9E09                   -9.99  |  48.00   | -9.9E-09   -9.9  -9.9  |
+  3 NO        |    -999.9  |  8.0E-06   0.62 |  1.0   1.0   |  1.2  3.0e-03  0.0 | -9.9E09                   -9.99  |  30.00   | -9.9E-09   -9.9  -9.9  |
+  4 NO2       |    -999.9  |  1.0E-05   0.62 |  1.0   1.0   |  1.6  1.0e-02  0.1 | -9.9E09                   -9.99  |  46.00   | -9.9E-09   -9.9  -9.9  |
+  5 HNO3      |    -999.9  |  5.0E-05   0.62 |  1.0   1.0   |  1.9  1.0e+14  0.0 | -9.9E09                   -9.99  |  63.00   | -9.9E-09   -9.9  -9.9  |
+  6 HNO2      |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   |  1.6  1.0e+05  0.1 | -9.9E09                   -9.99  |  47.00   | -9.9E-09   -9.9  -9.9  |
+  7 H2O2      |    -999.9  |  1.0E-04   0.62 |  1.0   1.0   |  1.4  1.0e+05  1.0 | -9.9E09                   -9.99  |  34.00   | -9.9E-09   -9.9  -9.9  |
+  8 SO2var    |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   |  2.0  1.0e+05  0.0 | -9.9E09                   -9.99  |  64.00   | -9.9E-09   -9.9  -9.9  |
+  9 HCHO      |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   |  1.3  6.0e+03  0.0 | -9.9E09                   -9.99  |  30.00   | -9.9E-09   -9.9  -9.9  |
+ 10 PAN       |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   |  2.6  3.6e+00  0.1 | -9.9E09                   -9.99  | 121.00   | -9.9E-09   -9.9  -9.9  |
+ 11 NH3       |    -999.9  |  9.9E-05   0.62 |  1.0   1.0   |  1.1  2.0e+14  0.0 | -9.9E09                   -9.99  |  17.00   | -9.9E-09   -9.9  -9.9  |
+ 12 SO4-aero  |    -999.9  |    1.0     1.0  |  0.9   0.1   | -9.9               |  2.0E03  4.0E-7  3.0E-1   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 13 NO3-aero  |    -999.9  |    1.0     1.0  |  0.9   0.1   | -9.9               |  2.0E03  4.0E-7  3.0E-1   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 14 I2-131    |  691200.0  |  8.0E-05   0.62 |  1.0   1.0   |  2.7  1.0e+05  0.1 | -9.9E09                   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 15 I-131     |  691200.0  |    1.0     1.0  |  0.9   0.1   | -9.9               |  2.5E03  6.0E-7  3.0E-1   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 16 Cs-137    |    -999.9  |    1.0     1.0  |  0.9   0.1   | -9.9               |  2.5E03  6.0E-7  3.0E-1   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 17 Y-91      | 5037120.0  |    1.0     1.0  |  0.9   0.1   | -9.9               |  2.5E03  6.0E-7  3.0E-1   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 18 Ru-106    |31536000.0  |    1.0     1.0  |  0.9   0.1   | -9.9               |  2.5E03  6.0E-7  3.0E-1   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 19 Kr-85     |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   | -9.9               | -9.9E09                   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 20 Sr-90     |    -999.9  |    1.0     1.0  |  0.9   0.1   | -9.9               |  2.5E03  6.0E-7  3.0E-1   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 21 Xe-133    |  453168.0  |   -9.9    -9.9  | -9.9  -9.9   | -9.9               | -9.9E09                   -9.99  |  -9.99   | -9.9E-09   -9.9  -9.9  |
+ 22 CO        |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   | -9.9               | -9.9E09                   -9.99  |  28.00   |  ?          ?      ?   |
+ 23 SO2dryOH  |            |                 |              |                    |                                  |          |  ?          ?      ?   |
+ 24 AIRTRACER |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   | -9.9               | -9.9E09                   -9.99  |  29.00   | -9.9E-09   -9.9  -9.9  |
+ 25 AEROTRACER|    -999.9  |    1.0     1.0  |  0.9   0.1   | -9.9               | 1.4E+03  2.5E-07   1.25   -9.99  |  29.00   | -9.9E-09   -9.9  -9.9  |
+ 26 CH4       |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   | -9.9               | -9.9E09                   -9.99  |  16.00   | 9.65E-20 1082.0   2.58 |
+ 27 C2H6      |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   | -9.9               | -9.9E09                   -9.99  |  30.00   | 15.2E-18  498.0   2.0  |
+ 28 C3H8      |    -999.9  |   -9.9    -9.9  | -9.9  -9.9   | -9.9               | -9.9E09                   -9.99  |  44.00   | 15.5E-18   61.0   2.0  |
+ x PCB28      |    -999.9  |    5E-06   0.62 | -9.9  -9.9   |  3.8  3.1e-00  0.0 | -9.9E09                   -9.99  | 257.54   |  ?           ?    2.0  |
+ x PCB101     |    -999.9  |    5E-06   0.62 | -9.9  -9.9   |  4.3  3.2e-00  0.0 | -9.9E09                   -9.99  | 326.43   |  ?           ?    2.0  |
+ x PCB180     |    -999.9  |    5E-06   0.62 | -9.9  -9.9   |  4.7  1.7e+01  0.0 | -9.9E09                   -9.99  | 395.32   |  ?           ?    2.0  |
+--------------------------------------------------------------------------------------------------------------------------------------------------------|
+** unit [cm^3/molec/s] (in FLEXPART version 9.2 and below this had unit [cm3/s], note the unit is now changed!)
+*** no unit
+
+UPDATE FOR FLEXPART VERSION 10.0 DEV:
+---------------------------------------------------------------------------------------------------------------------------
+Please note that the format of the SPECIES files has changed from the previous version (9.2) of FLEXPART and it is important
+to update all SPECIES files accordingly. The use of SPECIES files from older FLEXPART versions may lead to run-time
+errors or erroneous results.
+---------------------------------------------------------------------------------------------------------------------------
+Half life due to radioactive or chemical decay and can be switched off by specifying a negative value.
+Molecular weight (molweight of the species, needed for mixing ratio output)
+---------------------------------------------------------------------------------------------------------------------------
+WET DEPOSITION
+
+Below-cloud scavenging
+- Gases:
+	A and B are the parameters for below-cloud scavenging defined by Eq. scavenging coefficient = A x precipitation-rate^B
+- Particles: 
+	A "rain collection efficiency"  
+	B "snow collection efficiency" are both defined by Equations 46-47.
+	Suggested values for particle scavenging are A=1.0,B=1.0.
+	Using values A=0.2 and B=0.2 will give results close to the old scavenging scheme of FLEXPART version 9.2 and below.
+
+In-cloud scavenging
+- Gases:
+    Is switched on if Ai or Bi are given greater than 0
+- Particles:
+	Ai ("Cloud Condensation Nuclei (CCN) efficiency") 
+	Bi ("Ice Nuclei (IN) efficiency")                  are both from Eq. 51. 	
+	Suggested values for particle scavenging are  Ai=0.9 and Bi=0.1.
+	Using values Ai=0.9 and Bi=0.9 should give results cto the old scavenging scheme of FLEXPART version 9.2 and below.
+---------------------------------------------------------------------------------------------------------------------------
+DRY DEPOSITION
+- Gases: 
+	D is the diffusivity of water vapor and 
+	D_i is the diffusivity of the species, 
+	H is the effective Henry’s constant, 
+	f0 varies between 0 and 1 and gives the reactivity of a species relative to that of ozone. For non-reactive species f0 is 0, for slightly reactive it is 0.1 and for highly reactive it is 1. 
+	Dry deposition of gases is switched off by negative D. 
+- Particles:
+	rho specifies the density of the substance, 
+	dquer its mean diameter 
+	dsig the measure of variation.
+	If no detailed information for deposition velocity calculation is available, a constant deposition velocity vd [cm s-1] can be used. 
+	Dry deposition of particles is switched off by negative rho.
+---------------------------------------------------------------------------------------------------------------------------
+OH REACTION:
+	can be turned on by giving parameter C [cm^3/molecule/sec]], D [K] and N [no unit] positive values, defined by Eq. 39.
+	OH reaction is switched off by negative C.
+---------------------------------------------------------------------------------------------------------------------------
+Optionally  emission variation information 
+	can be added at the end of the file, defined as following: Since FLEXPART version 6.0, emission factors can be defined that change the temporal variation of particle releases. This is useful, for instance,
+to simulate the typical daily and weekly cycle of anthropogenic emissions. The emission factors are given in the file of the
+corresponding species SPECIES_nnn, where nnn is the species number defined in file RELEASES. If no emission variation
+information is given, emission rates for species nnn are taken as constant. Release rates can vary with the hour of the day
+and with the day of the week, according to the local time at the release location. Emission factors must be 1 on average. 24
+hourly as well as 7 daily values must be specified. Furthermore, different disaggregation factors must be given for area sources
+and for point sources. FLEXPART distinguishes between the two using the lower altitude of the release box: area sources are
+assumed to start below 0.5 m above the ground, whereas point sources are assumed to be higher. Please note that when this
+option is used, it is not so easy to determine the maximum number of particles present at a particular time of the model run. It
+might then be necessary to increase the parameter maxpart to a higher value than what would otherwise be needed.