Index: options/SPECIES/SPECIES_002
===================================================================
--- options/SPECIES/SPECIES_002	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_002	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -4,6 +4,4 @@
  PHENRY=  1.0E-02,
  PF0=  1.00000000    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
  PWEIGHTMOLAR=  48.0000000    ,
  /
Index: options/SPECIES/SPECIES_003
===================================================================
--- options/SPECIES/SPECIES_003	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_003	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -5,6 +5,4 @@
  PRELDIFF=  1.2    ,
  PHENRY=  3.0E-03,
- PF0=  0.0    ,
- PDQUER=  0.00000000    ,
  PWEIGHTMOLAR=  30.0000000    ,
  /
Index: options/SPECIES/SPECIES_004
===================================================================
--- options/SPECIES/SPECIES_004	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_004	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -2,10 +2,8 @@
  PSPECIES="NO2             ",
  PWETA_GAS=  1.0E-05,
- PWETB_GAS= 0.620000005    ,
- PRELDIFF=  1.60000002    ,
+ PWETB_GAS= 0.62    ,
+ PRELDIFF=  1.6    ,
  PHENRY=  1.0E-02,
  PF0= 0.1    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
  PWEIGHTMOLAR=  46.0000000    ,
  /
Index: options/SPECIES/SPECIES_005
===================================================================
--- options/SPECIES/SPECIES_005	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_005	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -5,7 +5,4 @@
  PRELDIFF=  1.9    ,
  PHENRY=  1.00000000E+14,
- PF0=  0.00000000    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
  PWEIGHTMOLAR=  63.0000000    ,
  /
Index: options/SPECIES/SPECIES_006
===================================================================
--- options/SPECIES/SPECIES_006	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_006	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -4,6 +4,4 @@
  PHENRY=  100000.000    ,
  PF0= 0.1    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
  PWEIGHTMOLAR=  47.0000000    ,
  /
Index: options/SPECIES/SPECIES_007
===================================================================
--- options/SPECIES/SPECIES_007	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_007	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -1,5 +1,4 @@
 &SPECIES_PARAMS
  PSPECIES="H2O2            ",
- PDECAY= -999.900024    ,
  PWETA_GAS=  1.0E-04,
  PWETB_GAS= 0.62    ,
@@ -7,6 +6,4 @@
  PHENRY=  100000.000    ,
  PF0=  1.00000000    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
  PWEIGHTMOLAR=  34.0000000    ,
  /
Index: options/SPECIES/SPECIES_009
===================================================================
--- options/SPECIES/SPECIES_009	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_009	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -3,7 +3,4 @@
  PRELDIFF=  1.3    ,
  PHENRY=  6000.00000    ,
- PF0=  0.00000000    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
  PWEIGHTMOLAR=  30.0000000    ,
  /
Index: options/SPECIES/SPECIES_010
===================================================================
--- options/SPECIES/SPECIES_010	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_010	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -4,6 +4,4 @@
  PHENRY=  3.6    ,
  PF0= 0.1    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
  PWEIGHTMOLAR=  121.000000    ,
  /
Index: options/SPECIES/SPECIES_011
===================================================================
--- options/SPECIES/SPECIES_011	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_011	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -5,7 +5,4 @@
  PRELDIFF=  1.1    ,
  PHENRY=  2.0E+14,
- PF0=  0.00000000    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
  PWEIGHTMOLAR=  17.0000000    ,
  /
Index: options/SPECIES/SPECIES_012
===================================================================
--- options/SPECIES/SPECIES_012	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_012	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -8,4 +8,3 @@
  PDQUER=4.0E-07   ,
  PDSIGMA=0.3    ,
- PWEIGHTMOLAR=  -9.9    ,
  /
Index: options/SPECIES/SPECIES_013
===================================================================
--- options/SPECIES/SPECIES_013	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_013	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -1,13 +1,10 @@
 &SPECIES_PARAMS
  PSPECIES="NO3-aero        ",
- PCRAIN_AERO=  1.00000000    ,
- PCSNOW_AERO=  1.00000000    ,
+ PCRAIN_AERO=  1.0    ,
+ PCSNOW_AERO=  1.0    ,
  PCCN_AERO= 0.9    ,
  PIN_AERO= 0.1    ,
- PHENRY=  0.00000000    ,
- PF0=  0.00000000    ,
  PDENSITY=  2000.00000    ,
  PDQUER=  4.0E-07,
  PDSIGMA= 0.3    ,
- PWEIGHTMOLAR= -9.99    ,
  /
Index: options/SPECIES/SPECIES_014
===================================================================
--- options/SPECIES/SPECIES_014	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_014	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -7,6 +7,3 @@
  PHENRY=  100000.000    ,
  PF0= 0.1    ,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
- PWEIGHTMOLAR= -9.99    ,
  /
Index: options/SPECIES/SPECIES_015
===================================================================
--- options/SPECIES/SPECIES_015	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_015	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -2,13 +2,10 @@
  PSPECIES="I-131           ",
  PDECAY=  691200.000    ,
- PCRAIN_AERO=  1.00000000    ,
- PCSNOW_AERO=  1.00000000    ,
+ PCRAIN_AERO=  1.0    ,
+ PCSNOW_AERO=  1.0    ,
  PCCN_AERO= 0.9    ,
  PIN_AERO= 0.1    ,
- PHENRY=  0.00000000    ,
- PF0=  0.00000000    ,
  PDENSITY=  2500.00000    ,
  PDQUER=  6.0E-07,
  PDSIGMA= 0.3    ,
- PWEIGHTMOLAR= -9.9    ,
  /
Index: options/SPECIES/SPECIES_017
===================================================================
--- options/SPECIES/SPECIES_017	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_017	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -2,13 +2,10 @@
  PSPECIES="Y-91            ",
  PDECAY=  5037120.00    ,
- PCRAIN_AERO=  1.00000000    ,
- PCSNOW_AERO=  1.00000000    ,
+ PCRAIN_AERO=  1.0    ,
+ PCSNOW_AERO=  1.0    ,
  PCCN_AERO= 0.9    ,
  PIN_AERO= 0.1    ,
- PHENRY=  0.00000000    ,
- PF0=  0.00000000    ,
  PDENSITY=  2500.00000    ,
  PDQUER=  6.0E-07,
  PDSIGMA= 0.3    ,
- PWEIGHTMOLAR= -9.9    ,
  /
Index: options/SPECIES/SPECIES_018
===================================================================
--- options/SPECIES/SPECIES_018	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_018	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -2,13 +2,10 @@
  PSPECIES="Ru-106          ",
  PDECAY=  31536000.0    ,
- PCRAIN_AERO=  1.00000000    ,
- PCSNOW_AERO=  1.00000000    ,
+ PCRAIN_AERO=  1.0    ,
+ PCSNOW_AERO=  1.0    ,
  PCCN_AERO= 0.9    ,
  PIN_AERO= 0.1    ,
- PHENRY=  0.00000000    ,
- PF0=  0.00000000    ,
  PDENSITY=  2500.00000    ,
  PDQUER=  6.0E-07,
  PDSIGMA= 0.3    ,
- PWEIGHTMOLAR=  -9.9    ,
  /
Index: options/SPECIES/SPECIES_019
===================================================================
--- options/SPECIES/SPECIES_019	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_019	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -1,5 +1,3 @@
 &SPECIES_PARAMS
  PSPECIES="Kr-85           ",
- PDENSITY= -9.9E+09,
- PWEIGHTMOLAR= -9.9    ,
  /
Index: options/SPECIES/SPECIES_020
===================================================================
--- options/SPECIES/SPECIES_020	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_020	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -1,7 +1,6 @@
 &SPECIES_PARAMS
  PSPECIES="Sr-90           ",
- PDECAY= -999.900024    ,
- PCRAIN_AERO=  1.00000000    ,
- PCSNOW_AERO=  1.00000000    ,
+ PCRAIN_AERO=  1.0    ,
+ PCSNOW_AERO=  1.0    ,
  PCCN_AERO= 0.9    ,
  PIN_AERO= 0.1    ,
@@ -9,4 +8,3 @@
  PDQUER=  6.0E-07,
  PDSIGMA= 0.3    ,
- PWEIGHTMOLAR=  -9.9    ,
  /
Index: options/SPECIES/SPECIES_021
===================================================================
--- options/SPECIES/SPECIES_021	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_021	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -2,4 +2,3 @@
  PSPECIES="Xe-133          ",
  PDECAY=  453168.000    ,
- PWEIGHTMOLAR=  -9.9    ,
  /
Index: options/SPECIES/SPECIES_024
===================================================================
--- options/SPECIES/SPECIES_024	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_024	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -1,23 +1,4 @@
 &SPECIES_PARAMS
  PSPECIES="AIRTRACER       ",
- PDECAY= -999.900024    ,
- PWETA_GAS= -9.89999962    ,
- PWETB_GAS= -9.89999962    ,
- PCRAIN_AERO= -9.89999962    ,
- PCSNOW_AERO= -9.89999962    ,
- PCCN_AERO= -9.89999962    ,
- PIN_AERO= -9.89999962    ,
- PRELDIFF= -9.89999962    ,
- PHENRY=  0.00000000    ,
- PF0=  0.00000000    ,
- PDENSITY= -9.90000026E+09,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
- PDRYVEL= -9.98999977    ,
  PWEIGHTMOLAR=  29.0000000    ,
- POHCCONST= -9.98999994E-09,
- POHDCONST= -9.89999962    ,
- POHNCONST= -9.89999962    ,
- PSPEC_ASS= -9.00000000    ,
- PKAO= -99.9899979    ,
  /
Index: options/SPECIES/SPECIES_026
===================================================================
--- options/SPECIES/SPECIES_026	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_026	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -1,5 +1,4 @@
 &SPECIES_PARAMS
  PSPECIES="CH4             ",
- PDENSITY= -9.9+09,
  PWEIGHTMOLAR=  16.0000000    ,
  POHCCONST=  9.65E-20,
Index: options/SPECIES/SPECIES_027
===================================================================
--- options/SPECIES/SPECIES_027	(revision 341f4b7eb1c45f4749b96fc8dbea2dfff30140f2)
+++ options/SPECIES/SPECIES_027	(revision e4f26d11a6c1dc1c16840e116eca0b5de8251a05)
@@ -1,23 +1,6 @@
 &SPECIES_PARAMS
  PSPECIES="C2H6            ",
- PDECAY= -999.900024    ,
- PWETA_GAS= -9.89999962    ,
- PWETB_GAS= -9.89999962    ,
- PCRAIN_AERO= -9.89999962    ,
- PCSNOW_AERO= -9.89999962    ,
- PCCN_AERO= -9.89999962    ,
- PIN_AERO= -9.89999962    ,
- PRELDIFF= -9.89999962    ,
- PHENRY=  0.00000000    ,
- PF0=  0.00000000    ,
- PDENSITY= -9.90000026E+09,
- PDQUER=  0.00000000    ,
- PDSIGMA=  0.00000000    ,
- PDRYVEL= -9.98999977    ,
  PWEIGHTMOLAR=  30.0000000    ,
- POHCCONST=  1.51999996E-17,
  POHDCONST=  498.000000    ,
  POHNCONST=  2.00000000    ,
- PSPEC_ASS= -9.00000000    ,
- PKAO= -99.9899979    ,
  /